diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.41/src/wifi/helper/wifi-mac-helper.cc ns-3.42/src/wifi/helper/wifi-mac-helper.cc
--- ns-3.41/src/wifi/helper/wifi-mac-helper.cc	2024-02-09 14:44:08.573794800 -0800
+++ ns-3.42/src/wifi/helper/wifi-mac-helper.cc	2024-05-29 15:29:47.196073800 -0700
@@ -22,14 +22,19 @@
 #include "ns3/boolean.h"
 #include "ns3/eht-configuration.h"
 #include "ns3/emlsr-manager.h"
+#include "ns3/enum.h"
 #include "ns3/frame-exchange-manager.h"
 #include "ns3/multi-user-scheduler.h"
+#include "ns3/pointer.h"
 #include "ns3/wifi-ack-manager.h"
 #include "ns3/wifi-assoc-manager.h"
 #include "ns3/wifi-mac-queue-scheduler.h"
 #include "ns3/wifi-net-device.h"
 #include "ns3/wifi-protection-manager.h"
 
+#include <sstream>
+#include <vector>
+
 namespace ns3
 {
 
@@ -38,6 +43,17 @@
     // By default, we create an AdHoc MAC layer (without QoS).
     SetType("ns3::AdhocWifiMac");
 
+    m_dcf.SetTypeId("ns3::Txop");
+    for (const auto& [aci, ac] : wifiAcList)
+    {
+        auto [it, inserted] = m_edca.try_emplace(aci);
+        it->second.SetTypeId("ns3::QosTxop");
+    }
+    m_channelAccessManager.SetTypeId("ns3::ChannelAccessManager");
+    // Setting FEM attributes requires setting a TypeId first. We initialize the TypeId to the FEM
+    // of the latest standard, in order to allow users to set the attributes of all the FEMs. The
+    // Create method will set the requested standard before creating the FEM(s).
+    m_frameExchangeManager.SetTypeId(GetFrameExchangeManagerTypeIdName(WIFI_STANDARD_COUNT, true));
     m_assocManager.SetTypeId("ns3::WifiDefaultAssocManager");
     m_queueScheduler.SetTypeId("ns3::FcfsWifiQueueScheduler");
     m_protectionManager.SetTypeId("ns3::WifiDefaultProtectionManager");
@@ -61,45 +77,69 @@
         macObjectFactory.Set("QosSupported", BooleanValue(true));
     }
 
+    // do not create a Txop if the standard is at least 802.11n
+    if (standard < WIFI_STANDARD_80211n)
+    {
+        auto dcf = m_dcf; // create a copy because this is a const method
+        dcf.Set("AcIndex", EnumValue<AcIndex>(AC_BE_NQOS));
+        macObjectFactory.Set("Txop", PointerValue(dcf.Create<Txop>()));
+    }
+    // create (Qos)Txop objects
+    for (auto [aci, edca] : m_edca)
+    {
+        edca.Set("AcIndex", EnumValue<AcIndex>(aci));
+        std::stringstream ss;
+        ss << aci << "_Txop";
+        auto s = ss.str().substr(3); // discard "AC "
+        macObjectFactory.Set(s, PointerValue(edca.Create<QosTxop>()));
+    }
+
+    // WaveNetDevice (through ns-3.38) stores PHY entities in a different member than WifiNetDevice,
+    // hence GetNPhys() would return 0
+    auto nLinks = std::max<uint8_t>(device->GetNPhys(), 1);
+
+    // create Channel Access Managers
+    std::vector<Ptr<ChannelAccessManager>> caManagers;
+    for (uint8_t linkId = 0; linkId < nLinks; ++linkId)
+    {
+        caManagers.emplace_back(m_channelAccessManager.Create<ChannelAccessManager>());
+    }
+
     Ptr<WifiMac> mac = macObjectFactory.Create<WifiMac>();
     mac->SetDevice(device);
     mac->SetAddress(Mac48Address::Allocate());
     device->SetMac(mac);
-    mac->ConfigureStandard(standard);
-
-    Ptr<WifiMacQueueScheduler> queueScheduler = m_queueScheduler.Create<WifiMacQueueScheduler>();
-    mac->SetMacQueueScheduler(queueScheduler);
+    mac->SetChannelAccessManagers(caManagers);
 
-    // WaveNetDevice (through ns-3.38) stores PHY entities in a different member than WifiNetDevice,
-    // hence GetNPhys() would return 0. We have to attach a protection manager and an ack manager to
-    // the unique instance of frame exchange manager anyway
-    for (uint8_t linkId = 0; linkId < std::max<uint8_t>(device->GetNPhys(), 1); ++linkId)
+    // create Frame Exchange Managers, each with an attached protection manager and ack manager
+    std::vector<Ptr<FrameExchangeManager>> feManagers;
+    auto frameExchangeManager = m_frameExchangeManager;
+    frameExchangeManager.SetTypeId(
+        GetFrameExchangeManagerTypeIdName(standard, mac->GetQosSupported()));
+    for (uint8_t linkId = 0; linkId < nLinks; ++linkId)
     {
-        auto fem = mac->GetFrameExchangeManager(linkId);
+        auto fem = frameExchangeManager.Create<FrameExchangeManager>();
+        feManagers.emplace_back(fem);
 
-        Ptr<WifiProtectionManager> protectionManager =
-            m_protectionManager.Create<WifiProtectionManager>();
+        auto protectionManager = m_protectionManager.Create<WifiProtectionManager>();
         protectionManager->SetWifiMac(mac);
         protectionManager->SetLinkId(linkId);
         fem->SetProtectionManager(protectionManager);
 
-        Ptr<WifiAckManager> ackManager = m_ackManager.Create<WifiAckManager>();
+        auto ackManager = m_ackManager.Create<WifiAckManager>();
         ackManager->SetWifiMac(mac);
         ackManager->SetLinkId(linkId);
         fem->SetAckManager(ackManager);
 
-        // 11be MLDs require a MAC address to be assigned to each STA. Note that
-        // FrameExchangeManager objects are created by WifiMac::SetupFrameExchangeManager
-        // (which is invoked by WifiMac::ConfigureStandard, which is called above),
-        // which sets the FrameExchangeManager's address to the address held by WifiMac.
-        // Hence, in case the number of PHY objects is 1, the FrameExchangeManager's
-        // address equals the WifiMac's address.
-        if (device->GetNPhys() > 1)
-        {
-            fem->SetAddress(Mac48Address::Allocate());
-        }
+        // 11be MLDs require a MAC address to be assigned to each STA
+        fem->SetAddress(device->GetNPhys() > 1 ? Mac48Address::Allocate() : mac->GetAddress());
     }
 
+    mac->SetFrameExchangeManagers(feManagers);
+
+    Ptr<WifiMacQueueScheduler> queueScheduler = m_queueScheduler.Create<WifiMacQueueScheduler>();
+    mac->SetMacQueueScheduler(queueScheduler);
+
     // create and install the Multi User Scheduler if this is an HE AP
     Ptr<ApWifiMac> apMac;
     if (standard >= WIFI_STANDARD_80211ax && m_muScheduler.IsTypeIdSet() &&
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.41/src/wifi/helper/wifi-mac-helper.h ns-3.42/src/wifi/helper/wifi-mac-helper.h
--- ns-3.41/src/wifi/helper/wifi-mac-helper.h	2024-02-09 14:44:08.573794800 -0800
+++ ns-3.42/src/wifi/helper/wifi-mac-helper.h	2024-05-29 15:29:47.196073800 -0700
@@ -21,8 +21,11 @@
 #define WIFI_MAC_HELPER_H
 
 #include "ns3/object-factory.h"
+#include "ns3/qos-utils.h"
 #include "ns3/wifi-standards.h"
 
+#include <map>
+
 namespace ns3
 {
 
@@ -69,6 +72,43 @@
     void SetType(std::string type, Args&&... args);
 
     /**
+     * Helper function used to create and set the Txop object.
+     *
+     * \tparam Args \deduced Template type parameter pack for the sequence of name-value pairs.
+     * \param args A sequence of name-value pairs of the attributes to set.
+     */
+    template <typename... Args>
+    void SetDcf(Args&&... args);
+
+    /**
+     * Helper function used to create and set the QosTxop object corresponding to the given AC.
+     *
+     * \param aci the AC index
+     * \tparam Args \deduced Template type parameter pack for the sequence of name-value pairs.
+     * \param args A sequence of name-value pairs of the attributes to set.
+     */
+    template <typename... Args>
+    void SetEdca(AcIndex aci, Args&&... args);
+
+    /**
+     * Helper function used to set the Channel Access Manager object.
+     *
+     * \tparam Args \deduced Template type parameter pack for the sequence of name-value pairs.
+     * \param args A sequence of name-value pairs of the attributes to set.
+     */
+    template <typename... Args>
+    void SetChannelAccessManager(Args&&... args);
+
+    /**
+     * Helper function used to set the Frame Exchange Manager object.
+     *
+     * \tparam Args \deduced Template type parameter pack for the sequence of name-value pairs.
+     * \param args A sequence of name-value pairs of the attributes to set.
+     */
+    template <typename... Args>
+    void SetFrameExchangeManager(Args&&... args);
+
+    /**
      * Helper function used to set the Association Manager.
      *
      * \tparam Args \deduced Template type parameter pack for the sequence of name-value pairs.
@@ -139,13 +179,17 @@
     virtual Ptr<WifiMac> Create(Ptr<WifiNetDevice> device, WifiStandard standard) const;
 
   protected:
-    ObjectFactory m_mac;               ///< MAC object factory
-    ObjectFactory m_assocManager;      ///< Association Manager
-    ObjectFactory m_queueScheduler;    ///< MAC queue scheduler
-    ObjectFactory m_protectionManager; ///< Factory to create a protection manager
-    ObjectFactory m_ackManager;        ///< Factory to create an acknowledgment manager
-    ObjectFactory m_muScheduler;       ///< Multi-user Scheduler object factory
-    ObjectFactory m_emlsrManager;      ///< EMLSR Manager object factory
+    ObjectFactory m_mac;                                     ///< MAC object factory
+    ObjectFactory m_dcf;                                     ///< Txop (DCF) object factory
+    std::map<AcIndex, ObjectFactory, std::greater<>> m_edca; ///< QosTxop (EDCA) object factories
+    ObjectFactory m_channelAccessManager; ///< Channel Access Manager object factory
+    ObjectFactory m_frameExchangeManager; ///< Frame Exchange Manager object factory
+    ObjectFactory m_assocManager;         ///< Association Manager
+    ObjectFactory m_queueScheduler;       ///< MAC queue scheduler
+    ObjectFactory m_protectionManager;    ///< Factory to create a protection manager
+    ObjectFactory m_ackManager;           ///< Factory to create an acknowledgment manager
+    ObjectFactory m_muScheduler;          ///< Multi-user Scheduler object factory
+    ObjectFactory m_emlsrManager;         ///< EMLSR Manager object factory
 };
 
 } // namespace ns3
@@ -166,6 +210,36 @@
 }
 
 template <typename... Args>
+void
+WifiMacHelper::SetDcf(Args&&... args)
+{
+    m_dcf.Set(args...);
+}
+
+template <typename... Args>
+void
+WifiMacHelper::SetEdca(AcIndex aci, Args&&... args)
+{
+    auto it = m_edca.find(aci);
+    NS_ASSERT_MSG(it != m_edca.cend(), "No object factory for " << aci);
+    it->second.Set(args...);
+}
+
+template <typename... Args>
+void
+WifiMacHelper::SetChannelAccessManager(Args&&... args)
+{
+    m_channelAccessManager.Set(args...);
+}
+
+template <typename... Args>
+void
+WifiMacHelper::SetFrameExchangeManager(Args&&... args)
+{
+    m_frameExchangeManager.Set(args...);
+}
+
+template <typename... Args>
 void
 WifiMacHelper::SetAssocManager(std::string type, Args&&... args)
 {
